{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% trans "Real time map" %}{% endblock %}
{% block extrahead %}
<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
<link rel="stylesheet" type="text/css" href="{% static 'datatables1/datatables.min.css' %}"/>
<script type="text/javascript" src="{% static 'datatables1/datatables.min.js' %}"></script>
{% endblock %}
{% block content %}
<div class="page-header row mb-4">
    <div class="col-lg-8">
        <h1>{% trans "Real time map" %}</h1>
    </div>
</div>

<div class="pb-5">
    <div id="map" style="height: 600px;" class="mb-4"></div>
</div>

<script type="text/javascript">
    window.vehicles = {};
    window.updateMap = function () {
        $.get('{%  url "operators:vehicles-rt-ajax" %}', function (data) {
            for (let i=0; i<data.length; i++) {
                console.log(data[i]);
                if (data[i]["plate_number"] in window.vehicles) {
                    if ("marker" in window.vehicles[data[i]["plate_number"]]) {
                        let newLat = parseFloat(data[i]["last_pos"][0]);
                        let newLng = parseFloat(data[i]["last_pos"][1]);
                        let marker = window.vehicles[data[i]["plate_number"]]["marker"];
                        if (marker._latlng.lat != newLat || marker._latlng.lng != newLng) {
                            marker.setLatLng([newLat, newLng]);
                        }
                    }
                }
                else {
                    if (data[i]["last_pos"][0]) {
                        console.log(data[i]["last_pos"][0]);
                        window.vehicles[data[i]["plate_number"]] = {
                            "marker": L.marker(
                                [parseFloat(data[i]["last_pos"][0]), parseFloat(data[i]["last_pos"][1])],
                                {icon: window.carIcon}
                            )
                        };
                        window.vehicles[data[i]["plate_number"]]["marker"].addTo(window.layergroup).bindPopup(
                            "<b>" + data[i]["car_model"] + "</b> di " + data[i]["owner"] + "<br>" + data[i]["plate_number"]
                        );
                    }
                }
            }
        });
    }
    $(document).ready(function() {
        window.map = L.map('map').setView({{ MAP_DEFAULT_VIEW|safe }}, 13);
        window.layergroup = L.layerGroup().addTo(window.map);
        window.carIcon = L.icon({
            iconUrl: "{% static 'img/car.png' %}",
            iconSize: [38, 38],
            popupAnchor: [0, -10]
        });
        var tiles = L.tileLayer('//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 18,
            minZoom: 2,
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(window.map);
        window.updateMap();
        setInterval(window.updateMap, 10000);
    });
</script>

{% endblock %}